TimingWindow = {}

TimingWindow[#TimingWindow+1] = function()
	local Name = "Original"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.0225,
		['TapNoteScore_W2']=0.0450,
		['TapNoteScore_W3']=0.0900,
		['TapNoteScore_W4']=0.1350,
		['TapNoteScore_W5']=0.1800,
		['TapNoteScore_HitMine']=0.0900,
		['TapNoteScore_Attack']=0.1350,
		['TapNoteScore_Hold']=0.2500,
		['TapNoteScore_Roll']=0.5000,
		['TapNoteScore_Checkpoint']=0.1664,
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "Advanced"
	local Timings= {
		['TapNoteScore_ProW1']=0.000703125,
		['TapNoteScore_ProW2']=0.00140625,
		['TapNoteScore_ProW3']=0.0028125,
		['TapNoteScore_ProW4']=0.005625,
		['TapNoteScore_ProW5']=0.01125,
		['TapNoteScore_W1']=0.0225,
		['TapNoteScore_W2']=0.0450,
		['TapNoteScore_W3']=0.0900,
		['TapNoteScore_W4']=0.1350,
		['TapNoteScore_W5']=0.1800,
		['TapNoteScore_HitMine']=0.0900,
		['TapNoteScore_Attack']=0.1350,
		['TapNoteScore_Hold']=0.2500,
		['TapNoteScore_Roll']=0.5000,
		['TapNoteScore_Checkpoint']=0.1664,
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "ITG"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.023,
		['TapNoteScore_W2']=0.0445,
		['TapNoteScore_W3']=0.1035,
		['TapNoteScore_W4']=0.1365,
		['TapNoteScore_W5']=0.1815,
		['TapNoteScore_HitMine']=0.0715,
		['TapNoteScore_Attack']=0.1315,
		['TapNoteScore_Hold']=0.3215,
		['TapNoteScore_Roll']=0.3515,
		['TapNoteScore_Checkpoint']=0.1679, -- without this holds will never drop.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "ITG Advanced"
	local Timings= {
		['TapNoteScore_ProW1']=0.00071875,
		['TapNoteScore_ProW2']=0.0014375,
		['TapNoteScore_ProW3']=0.002875,
		['TapNoteScore_ProW4']=0.00575,
		['TapNoteScore_ProW5']=0.0115,
		['TapNoteScore_W1']=0.023,
		['TapNoteScore_W2']=0.0445,
		['TapNoteScore_W3']=0.1035,
		['TapNoteScore_W4']=0.1365,
		['TapNoteScore_W5']=0.1815,
		['TapNoteScore_HitMine']=0.0715,
		['TapNoteScore_Attack']=0.1315,
		['TapNoteScore_Hold']=0.3215,
		['TapNoteScore_Roll']=0.3515,
		['TapNoteScore_Checkpoint']=0.1679, -- without this holds will never drop.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "ECFA"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0.0115,
		['TapNoteScore_W1']=0.023,
		['TapNoteScore_W2']=0.0445,
		['TapNoteScore_W3']=0.1035,
		['TapNoteScore_W4']=0.1365,
		['TapNoteScore_W5']=0.1815,
		['TapNoteScore_HitMine']=0.0715,
		['TapNoteScore_Attack']=0.1315,
		['TapNoteScore_Hold']=0.3215,
		['TapNoteScore_Roll']=0.3515,
		['TapNoteScore_Checkpoint']=0.1679, -- without this holds will never drop.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "DDR"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.0150, -- Marvelous
		['TapNoteScore_W2']=0.0300, -- Perfect
		['TapNoteScore_W3']=0.0590, -- Great
		['TapNoteScore_W4']=0.0890, -- Good
		['TapNoteScore_W5']=0.1190, -- Boo
		['TapNoteScore_HitMine']=0.0900, -- Dunno this value, use Original.
		['TapNoteScore_Attack']=0.1350, -- Dunno this value, use Original.
		['TapNoteScore_Hold']=0.2500, -- Dunno this value, use Original.
		['TapNoteScore_Roll']=0.5000, -- Dunno this value, use Original.
		['TapNoteScore_Checkpoint']=0.1664, -- Dunno this value, use Original.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "BeatmaniaIIDX"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.0200, -- PGreat
		['TapNoteScore_W2']=0.0400, -- Great
		['TapNoteScore_W3']=0.1050, -- Good
		['TapNoteScore_W4']=0.,
		['TapNoteScore_W5']=0, -- doesn't exist.
		['TapNoteScore_HitMine']=0.0900, -- IIDX doesn't have, use Original.
		['TapNoteScore_Attack']=0.1350, -- IIDX doesn't have, use Original.
		['TapNoteScore_Hold']=0.2500, -- Dunno this value, use Original.
		['TapNoteScore_Roll']=0.5000, -- IIDX doesn't have, use Original.
		['TapNoteScore_Checkpoint']=0.1664, -- Dunno this value, use Original.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "Pop'n Music"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.0250, -- Cool
		['TapNoteScore_W2']=0.0500, -- Great
		['TapNoteScore_W3']=0.1000, -- Good
		['TapNoteScore_W4']=0, -- doesn't exist.
		['TapNoteScore_W5']=0, -- doesn't exist.
		['TapNoteScore_HitMine']=0.0900, -- Pop'n doesn't have, use Original.
		['TapNoteScore_Attack']=0.1350, -- Pop'n doesn't have, use Original.
		['TapNoteScore_Hold']=0.2500, -- Dunno this value, use Original.
		['TapNoteScore_Roll']=0.5000, -- Pop'n doesn't have, use Original.
		['TapNoteScore_Checkpoint']=0.1664, -- Dunno this value, use Original.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "GuitarFreaks"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.0330, -- Perfect
		['TapNoteScore_W2']=0.0570, -- Great
		['TapNoteScore_W3']=0.0810, -- Good
		['TapNoteScore_W4']=0.1770, -- Ok
		['TapNoteScore_W5']=0, -- doesn't exist.
		['TapNoteScore_HitMine']=0.0900, -- GuitarFreaks doesn't have, use Original.
		['TapNoteScore_Attack']=0.1350, -- GuitarFreaks doesn't have, use Original.
		['TapNoteScore_Hold']=0.2500, -- Dunno this value, use Original.
		['TapNoteScore_Roll']=0.5000, -- GuitarFreaks doesn't have, use Original.
		['TapNoteScore_Checkpoint']=0.1664, -- Dunno this value, use Original.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "Drummania"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.0270, -- Perfect
		['TapNoteScore_W2']=0.0480, -- Great
		['TapNoteScore_W3']=0.0720, -- Good
		['TapNoteScore_W4']=0.0960, -- Ok
		['TapNoteScore_W5']=0, -- doesn't exist.
		['TapNoteScore_HitMine']=0.0900, -- Drummania doesn't have, use Original.
		['TapNoteScore_Attack']=0.1350, -- Drummania doesn't have, use Original.
		['TapNoteScore_Hold']=0.2500, -- Dunno this value, use Original.
		['TapNoteScore_Roll']=0.5000, -- Drummania doesn't have, use Original.
		['TapNoteScore_Checkpoint']=0.1664, -- Dunno this value, use Original.
	};
	return Name, Timings
end

TimingWindow[#TimingWindow+1] = function()
	local Name = "ParaParaParadise"
	local Timings= {
		['TapNoteScore_ProW1']=0,
		['TapNoteScore_ProW2']=0,
		['TapNoteScore_ProW3']=0,
		['TapNoteScore_ProW4']=0,
		['TapNoteScore_ProW5']=0,
		['TapNoteScore_W1']=0.080, -- Great
		['TapNoteScore_W2']=0.180, -- Good
		['TapNoteScore_W3']=0, -- doesn't exist.
		['TapNoteScore_W4']=0, -- doesn't exist.
		['TapNoteScore_W5']=0, -- doesn't exist.
		['TapNoteScore_HitMine']=0.0900, -- Para doesn't have, use Original.
		['TapNoteScore_Attack']=0.1350, -- Para doesn't have, use Original.
		['TapNoteScore_Hold']=0.2500, -- Dunno this value, use Original.
		['TapNoteScore_Roll']=0.5000, -- Para doesn't have, use Original.
		['TapNoteScore_Checkpoint']=0.1664, -- Dunno this value, use Original.
	};
	return Name, Timings
end

function GetWindowSeconds(TimingWindow, Scale, Add)
	local fSecs = TimingWindow
	fSecs = fSecs * (Scale or 1.0) -- Timing Window Scale
	fSecs = fSecs + (Add or 0) --Timing Window Add
	return fSecs
end

------------------------------------------------------------------------------
-- Timing Call Definitions. -- Dont edit below this line - Jous
------------------------------------------------------------------------------

TimingModes = {}
for i,v in ipairs(TimingWindow) do
	Name,_ = TimingWindow[i]()
	table.insert(TimingModes,Name)
end

function TimingOrder(TimTab)
	local con = {}
	for k,v in pairs(TimTab) do
		if k == 'TapNoteScore_ProW1' then con[1] = {k,v} end
		if k == 'TapNoteScore_ProW2' then con[2] = {k,v} end
		if k == 'TapNoteScore_ProW3' then con[3] = {k,v} end
		if k == 'TapNoteScore_ProW4' then con[4] = {k,v} end
		if k == 'TapNoteScore_ProW5' then con[5] = {k,v} end
        if k == 'TapNoteScore_W1' then con[6] = {k,v} end
		if k == 'TapNoteScore_W2' then con[7] = {k,v} end
		if k == 'TapNoteScore_W3' then con[8] = {k,v} end
		if k == 'TapNoteScore_W4' then con[9] = {k,v} end
		if k == 'TapNoteScore_W5' then con[10] = {k,v} end
		if k == 'TapNoteScore_HitMine' then con[11] = {k,v} end
		if k == 'TapNoteScore_Attack' then con[12] = {k,v} end
		if k == 'TapNoteScore_Hold' then con[13] = {k,v} end
		if k == 'TapNoteScore_Roll' then con[14] = {k,v} end
		if k == 'TapNoteScore_Checkpoint' then con[15] = {k,v} end
	end
	return con
end